# Readme (poslední úprava: 28.3.2022)
Autor: Radek Henys [admin@mouseviator.com](mailto:admin@mouseviator.com)

## Pár slov úvodem

Co že je Mouseviator Enhanced Logbook pro Microsoft Flight Simulator 2020 (MSFS)? No, jde o malý doplněk, který jsem vytvořil, když jsem se snažil najít cestu jak získat přístup k logbooku v MSFS. A „cestu“ jsem našel, tak nějak, náhodou, ale …. funguje a je to cesta nejmenšího odporu.

Co může tento doplněk nabídnout navíc oproti limitované funkčnosti výchozího logbooku? Já mám za to, že na logbook v MSFS se nešáhlo, nebo jen velmi málo, od doby co MSFS vyšel. V logbooku je třeba o něco více dat, která nejsou zobrazena (jako například čas letu podle pravidel VFR). Asi je to kvůli tomu, že by tabulka byla pak hůře čitelná, kdyby zobrazovala všechny informace, ale jedna z věcí, kterou tento doplněk dělá, je, že tyto informace zobrazí. Druhou funkcí je možnost exportovat data z logbooku. Chtěl bych zopakovat slovo **EXPORTOVAT**, ano, pouze exportovat. Je možné data z logbooku **exportovat** mimo MSFS, ale <span style="color: red">**nelze je importovat dovnitř MSFS**</span> (nebo jakkoliv jinak modifikovat logbook v MSFS) !!! (To možná nikdy nebude možné 🙁 )

Proto jsem slovo „cestu“ v prvním odstavci uzavřel do uvozovek. Ani export není úplně přímočarý… Uživatelské rozhraní MSFS je totiž postavené na stejné technologii, jako webové stránky, a stejně jako nemůže webový prohlížeč ukládat soubory na počítač uživatele, není to možné (nebo nevím jak…) ani z rozhraní MSFS. Ale bylo možné to obejít exportem dat skrze **schránku** ve formátu JSON nebo CSV, nebo **přes síť**.

S exportem přes schránku můžete následně vložit data do programu dle svého uvážení – Poznámkového bloku, Wordu, Excelu… ale musíte si je pak zpracovat sami. I když, při exportu přes schránku s použitím formátu CSV, programy jako Excel nebo Libre Office Calc by měly při vložení dat formát CSV rozpoznat, nabídnout vám upravit možnosti importu CSV, což by mělo následně vést ke vložení příslušných informací do příslušných sloupců. Tedy, výsledkem bude tabulka. Takže to vlastně není tak složité. Ovšem, tento postup jsem netestoval na velkém množství dat. Problém je, že jsou všechna data kopírována v jednom kroku a je zde možnost, že se nebudou vejít… což by v nejhorším případě mohlo vést ke zhroucení simulátoru. Ale myslím, že by to vyžadovalo opravdu hodně zaznamenaných letů.

Bezpečnější je cesta exportu přes síť. Pro tu si ale buď musíte naprogramovat svůj vlastní „server“, který data přijme, nebo můžete použít [FS Logbook Editor](https://mouseviator.com/vytvory-pro-pc/fs-logbook-editor/), který od verze 1.8 podporuje obě cesty importu dat (jak přes schránku, tak přes síť). Export přes síť posílá data po menších částech, takže by nemělo záležet na tom, kolik jich v logbooku máte.

## Funkce a omezení

Doplněk umožňuje:

* Zobrazuje původně skrytá data, jako čas letu podle pravidel VFR a IFR.
* Přidává dva filtry – **Flights started** – tento zobrazí jen lety s platným letištěm startu (nic s Vicinity nebo podobným neurčitým umístěním…), což by měly být lety, které začaly na letišti. **Flights ended** – tento zobrazí jen lety s platným koncovým letištěm (nic s Vicinity nebo podobným neurčitým umístěním…), což by měly být lety, které skončily na letišti.
* Umožňuje **exportovat** data z logbooku pomocí schránky ve formátu JSON nebo CSV, nebo za použití sítě (s [FS Logbook Editorem](https://mouseviator.com/vytvory-pro-pc/fs-logbook-editor/)).

Omezení:

* Žádný IMPORT!!! Neumožňuje žádným způsobem modifikovat záznamy logbooku v MSFS.
* Chtěl jsem zpřístupnit tlačítko Favorite , které by mělo let označit jako „oblíbený“ a které je ve výchozím stavu skryto. I když je tlačíko napojené na akci v simulátoru, data v logbooku žádnou informaci o tom, že se jedná o oblíbený let, neobsahují, tedy je to zatím k ničemu.
* Chtěl jsem zpřístupnit tlačítko Add comment, které by mělo umožňovat přidat komentář k zaznamenanému letu. Ono ve skutečnosti funguje, ale nenašel jsem žádnou cestu další práce s komentáři. Bylo možné je jen přidat, ale ne odebrat, takže tlačítko zůstává skryté.
* Doplněk je pouze v Angličtině!!! MSFS v tomto případě kompletně ignoruje lockPack soubory… takže jsem musel všechny zprávy natvrdo napsat anglicky :(

## Licence

Zkusme to udělat jednoduché:

<p style="color: green">Můžete tento soubor **reuplodovat** bez toho, aby jste se mě plati, ale musíte mě správně uvést v poznámkách a přidat odkaz na tento soubor.</p>

<p style="color: green">Můžete tento soubor nebo jeho části **upravovat**, ale bych bych rád kdyby jste se mě nejdřív zeptali – (zajímá mě s jakými vylepšeními přijdete…). Musíte mě správně uvést v poznámkách a přidat odkaz na tento soubor.</p>

<p style="color: red">Jakékoliv použití tohoto souboru nebo projektů na něm založených, které by končilo finančním obohacením, je **zakázáno**, ale může být diskutováno. Tím myslím, že tento soubor ani projekty na něm založené nemůžete jednoduše prodávat. Tento doplněk je ZDARMA a má zůstat ZDARMA. Může ale dojít k případu použití, který mě teď nenapadá  a který se by se dal klasifikovat jako komerční, ačkoliv třeba akceptovatelný.</p>

## Instalace

### 1) Zkopírování složky mouseviator-enhanced-logbook na správné místo

Archiv, který si stáhnete, obsahuje složku **mouseviator-enhanced-logbook**. Jednoduše tuto složku zkopírujte do složky **Community** – pro komunitní balíčky vaší instalace Microsoft Flight Simulátoru.

Nalezení složky **Community** by dost možná mohla být ta komplikovanější část … než nějaké rozbalování archivu a přesouvání složek. No, pokud jste Flight Simulátoru neřekli aby ukládal balíčky tam kam vy chcete (jako já), zkuste se podívat do jednoho z výchozích umístění:

Pokud používáte Windows Store verzi (or Game Pass pro PC), pak se zkuste podívat zde:

```
C:\Users\[YOUR USERNAME]\AppData\Local\Packages\Microsoft.FlightSimulator_[RANDOM LETTERS]\LocalCache\Packages\Community
```

Pokud používáte Steam verzi, zkuste to zde:

```
C:\Users\[YOUR USERNAME]\AppData\Roaming\Microsoft Flight Simulator\Packages\Community
```

nebo

```
C:\Users\[YOUR USERNAME]\AppData\Local\Packages\Microsoft.FlightDashboard_[RANDOM LETTERS]\LocalCache\Packages\Community
```         

### 2) Spusťte MSFS a jděte na stránku s Logbookem

To je vše. MSFS už by teď měl o doplňku vědět a vy by jste na stránce s Logbookem měli vidět více informací, včetně těch dvou tlačítek na export logbooku.

## Kontakt

Pokud mě chcete ohledně čehokoliv kontaktovat (čehokoliv rozumného, žádný SPAM prosím), můžete tak učinit přes email níže.

Autor: Radek Henys<br/>
Email: [admin@mouseviator.com](mailto:admin@mouseviator.com) 